Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4105)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4106)
@@ -2819,384 +2900,255 @@
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_0d=var_int8_0d_pointer, return_value=return_value )
+                       var_int8_0d=var_int8_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int8_1d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_1d=var_int8_1d_pointer, return_value=return_value )
+                       var_int8_1d=var_int8_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int8_2d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_2d=var_int8_2d_pointer, return_value=return_value )
+                       var_int8_2d=var_int8_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int8_3d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_3d=var_int8_3d_pointer, return_value=return_value )
+                       var_int8_3d=var_int8_3d_pointer, return_value=output_return_value )
             !-- 16bit integer output
             ELSEIF ( PRESENT( var_int16_0d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_0d=var_int16_0d_pointer, return_value=return_value )
+                       var_int16_0d=var_int16_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int16_1d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_1d=var_int16_1d_pointer, return_value=return_value )
+                       var_int16_1d=var_int16_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int16_2d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_2d=var_int16_2d_pointer, return_value=return_value )
+                       var_int16_2d=var_int16_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int16_3d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_3d=var_int16_3d_pointer, return_value=return_value )
+                       var_int16_3d=var_int16_3d_pointer, return_value=output_return_value )
             !-- 32bit integer output
             ELSEIF ( PRESENT( var_int32_0d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_0d=var_int32_0d_pointer, return_value=return_value )
+                       var_int32_0d=var_int32_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int32_1d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_1d=var_int32_1d_pointer, return_value=return_value )
+                       var_int32_1d=var_int32_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int32_2d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_2d=var_int32_2d_pointer, return_value=return_value )
+                       var_int32_2d=var_int32_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int32_3d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_3d=var_int32_3d_pointer, return_value=return_value )
+                       var_int32_3d=var_int32_3d_pointer, return_value=output_return_value )
             !-- working-precision integer output
             ELSEIF ( PRESENT( var_intwp_0d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_0d=var_intwp_0d_pointer, return_value=return_value )
+                       var_intwp_0d=var_intwp_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_intwp_1d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_1d=var_intwp_1d_pointer, return_value=return_value )
+                       var_intwp_1d=var_intwp_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_intwp_2d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_2d=var_intwp_2d_pointer, return_value=return_value )
+                       var_intwp_2d=var_intwp_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_intwp_3d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_3d=var_intwp_3d_pointer, return_value=return_value )
+                       var_intwp_3d=var_intwp_3d_pointer, return_value=output_return_value )
             !-- 32bit real output
             ELSEIF ( PRESENT( var_real32_0d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_0d=var_real32_0d_pointer, return_value=return_value )
+                       var_real32_0d=var_real32_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real32_1d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_1d=var_real32_1d_pointer, return_value=return_value )
+                       var_real32_1d=var_real32_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real32_2d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_2d=var_real32_2d_pointer, return_value=return_value )
+                       var_real32_2d=var_real32_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real32_3d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_3d=var_real32_3d_pointer, return_value=return_value )
+                       var_real32_3d=var_real32_3d_pointer, return_value=output_return_value )
             !-- 64bit real output
             ELSEIF ( PRESENT( var_real64_0d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_0d=var_real64_0d_pointer, return_value=return_value )
+                       var_real64_0d=var_real64_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real64_1d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_1d=var_real64_1d_pointer, return_value=return_value )
+                       var_real64_1d=var_real64_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real64_2d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_2d=var_real64_2d_pointer, return_value=return_value )
+                       var_real64_2d=var_real64_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real64_3d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_3d=var_real64_3d_pointer, return_value=return_value )
+                       var_real64_3d=var_real64_3d_pointer, return_value=output_return_value )
             !-- working-precision real output
             ELSEIF ( PRESENT( var_realwp_0d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_0d=var_realwp_0d_pointer, return_value=return_value )
+                       var_realwp_0d=var_realwp_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_realwp_1d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_1d=var_realwp_1d_pointer, return_value=return_value )
+                       var_realwp_1d=var_realwp_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_realwp_2d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_2d=var_realwp_2d_pointer, return_value=return_value )
+                       var_realwp_2d=var_realwp_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_realwp_3d ) )  THEN
                CALL binary_write_variable( file_id, var_id,                                      &
                        bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_3d=var_realwp_3d_pointer, return_value=return_value )
+                       var_realwp_3d=var_realwp_3d_pointer, return_value=output_return_value )
             ELSE
                return_value = 1
-               CALL internal_message( 'error', routine_name //                                    &
-                                               ': variable "' // TRIM( name ) //                  &
-                                               '" in file "' // TRIM( filename ) //               &
-                                               '": output_type not supported by file format "' // &
-                                               TRIM( file_format ) // '"' )
+               CALL internal_message( 'error', routine_name //                           &
+                                      ': variable "' // TRIM( name ) //                  &
+                                      '" in file "' // TRIM( filename ) //               &
+                                      '": output_type not supported by file format "' // &
+                                      TRIM( file_format ) // '"' )
             ENDIF
 
-         CASE ( 'netcdf4-serial' )
+         CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
             !-- 8bit integer output
             IF ( PRESENT( var_int8_0d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_0d=var_int8_0d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int8_0d=var_int8_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int8_1d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_1d=var_int8_1d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int8_1d=var_int8_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int8_2d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_2d=var_int8_2d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int8_2d=var_int8_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int8_3d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_3d=var_int8_3d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int8_3d=var_int8_3d_pointer, return_value=output_return_value )
             !-- 16bit integer output
             ELSEIF ( PRESENT( var_int16_0d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_0d=var_int16_0d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int16_0d=var_int16_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int16_1d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_1d=var_int16_1d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int16_1d=var_int16_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int16_2d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_2d=var_int16_2d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int16_2d=var_int16_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int16_3d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_3d=var_int16_3d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int16_3d=var_int16_3d_pointer, return_value=output_return_value )
             !-- 32bit integer output
             ELSEIF ( PRESENT( var_int32_0d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_0d=var_int32_0d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int32_0d=var_int32_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int32_1d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_1d=var_int32_1d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int32_1d=var_int32_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int32_2d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_2d=var_int32_2d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int32_2d=var_int32_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_int32_3d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_3d=var_int32_3d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_int32_3d=var_int32_3d_pointer, return_value=output_return_value )
             !-- working-precision integer output
             ELSEIF ( PRESENT( var_intwp_0d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_0d=var_intwp_0d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_intwp_0d=var_intwp_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_intwp_1d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_1d=var_intwp_1d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_intwp_1d=var_intwp_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_intwp_2d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_2d=var_intwp_2d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_intwp_2d=var_intwp_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_intwp_3d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_3d=var_intwp_3d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_intwp_3d=var_intwp_3d_pointer, return_value=output_return_value )
             !-- 32bit real output
             ELSEIF ( PRESENT( var_real32_0d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_0d=var_real32_0d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real32_0d=var_real32_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real32_1d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_1d=var_real32_1d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real32_1d=var_real32_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real32_2d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_2d=var_real32_2d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real32_2d=var_real32_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real32_3d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_3d=var_real32_3d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real32_3d=var_real32_3d_pointer, return_value=output_return_value )
             !-- 64bit real output
             ELSEIF ( PRESENT( var_real64_0d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_0d=var_real64_0d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real64_0d=var_real64_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real64_1d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_1d=var_real64_1d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real64_1d=var_real64_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real64_2d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_2d=var_real64_2d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real64_2d=var_real64_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_real64_3d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_3d=var_real64_3d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_real64_3d=var_real64_3d_pointer, return_value=output_return_value )
             !-- working-precision real output
             ELSEIF ( PRESENT( var_realwp_0d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_0d=var_realwp_0d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_realwp_0d=var_realwp_0d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_realwp_1d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_1d=var_realwp_1d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_realwp_1d=var_realwp_1d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_realwp_2d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_2d=var_realwp_2d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_realwp_2d=var_realwp_2d_pointer, return_value=output_return_value )
             ELSEIF ( PRESENT( var_realwp_3d ) )  THEN
-               CALL netcdf4_serial_write_variable( file_id, var_id,                              &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_3d=var_realwp_3d_pointer, return_value=return_value )
+               CALL netcdf4_write_variable( file_id, var_id,                              &
+                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
+                       var_realwp_3d=var_realwp_3d_pointer, return_value=output_return_value )
             ELSE
                return_value = 1
-               CALL internal_message( 'error', routine_name //                                    &
-                                               ': variable "' // TRIM( name ) //                  &
-                                               '" in file "' // TRIM( filename ) //               &
-                                               '": output_type not supported by file format "' // &
-                                               TRIM( file_format ) // '"' )
-            ENDIF
-
-         CASE ( 'netcdf4-parallel' )
-            !-- 8bit integer output
-            IF ( PRESENT( var_int8_0d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_0d=var_int8_0d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int8_1d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_1d=var_int8_1d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int8_2d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_2d=var_int8_2d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int8_3d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int8_3d=var_int8_3d_pointer, return_value=return_value )
-            !-- 16bit integer output
-            ELSEIF ( PRESENT( var_int16_0d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_0d=var_int16_0d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int16_1d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_1d=var_int16_1d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int16_2d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_2d=var_int16_2d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int16_3d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int16_3d=var_int16_3d_pointer, return_value=return_value )
-            !-- 32bit integer output
-            ELSEIF ( PRESENT( var_int32_0d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_0d=var_int32_0d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int32_1d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_1d=var_int32_1d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int32_2d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_2d=var_int32_2d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_int32_3d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_int32_3d=var_int32_3d_pointer, return_value=return_value )
-            !-- working-precision integer output
-            ELSEIF ( PRESENT( var_intwp_0d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_0d=var_intwp_0d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_intwp_1d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_1d=var_intwp_1d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_intwp_2d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_2d=var_intwp_2d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_intwp_3d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_intwp_3d=var_intwp_3d_pointer, return_value=return_value )
-            !-- 32bit real output
-            ELSEIF ( PRESENT( var_real32_0d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_0d=var_real32_0d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_real32_1d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_1d=var_real32_1d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_real32_2d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_2d=var_real32_2d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_real32_3d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real32_3d=var_real32_3d_pointer, return_value=return_value )
-            !-- 64bit real output
-            ELSEIF ( PRESENT( var_real64_0d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_0d=var_real64_0d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_real64_1d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_1d=var_real64_1d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_real64_2d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_2d=var_real64_2d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_real64_3d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_real64_3d=var_real64_3d_pointer, return_value=return_value )
-            !-- working-precision real output
-            ELSEIF ( PRESENT( var_realwp_0d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_0d=var_realwp_0d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_realwp_1d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_1d=var_realwp_1d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_realwp_2d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_2d=var_realwp_2d_pointer, return_value=return_value )
-            ELSEIF ( PRESENT( var_realwp_3d ) )  THEN
-               CALL netcdf4_parallel_write_variable( file_id, var_id,                            &
-                       bounds_start_new, bounds_end_new, bounds_dim_start, do_output, is_global, &
-                       var_realwp_3d=var_realwp_3d_pointer, return_value=return_value )
-            ELSE
-               return_value = 1
-               CALL internal_message( 'error', routine_name //                                    &
-                                               ': variable "' // TRIM( name ) //                  &
-                                               '" in file "' // TRIM( filename ) //               &
-                                               '": output_type not supported by file format "' // &
-                                               TRIM( file_format ) // '"' )
+               CALL internal_message( 'error', routine_name //                           &
+                                      ': variable "' // TRIM( name ) //                  &
+                                      '" in file "' // TRIM( filename ) //               &
+                                      '": output_type not supported by file format "' // &
+                                      TRIM( file_format ) // '"' )
             ENDIF
 
